package com.example.HelloFlutterJava;

import androidx.annotation.NonNull;
import io.flutter.embedding.android.FlutterActivity;
import io.flutter.embedding.engine.FlutterEngine;
import io.flutter.plugin.common.MethodChannel;

import static ie.imobile.extremepush.PushConnector.mPushConnector;

public class MainActivity extends FlutterActivity {

    private static final String CHANNEL = "ie.imobile.xtremepush/flutter";

    @Override
    public void configureFlutterEngine(@NonNull FlutterEngine flutterEngine) {
        super.configureFlutterEngine(flutterEngine);
        new MethodChannel(flutterEngine.getDartExecutor().getBinaryMessenger(), CHANNEL)
                .setMethodCallHandler(
                        (call, result) -> {
                            // Note: this method is invoked on the main thread.
                            switch (call.method) {
                                case "hitEvent":
                                    final String xpEvent = call.argument("xpEvent");
                                    mPushConnector.hitEvent(xpEvent);
                                    break;
                                case "hitTag":
                                    final String xpTag = call.argument("xpTag");
                                    mPushConnector.hitTag(xpTag);
                                    break;
                                case "hitTagWithValue":
                                    final String xpTagw = call.argument("xpTag");
                                    final String xpTagValue = call.argument("xpTagValue");
                                    mPushConnector.hitTag(xpTagw, xpTagValue);
                                    break;
                                case "setUser":
                                    final String user_id = call.argument("xp_user_id");
                                    mPushConnector.setUser(user_id);
                                    break;
                                case "setTempUser":
                                    final String temp_user_id = call.argument("xp_temp_user_id");
                                    mPushConnector.setTempUser(temp_user_id);
                                    break;
                                case "openInbox":
                                    mPushConnector.openInbox(this);
                                    break;
                                case "setSubscription":
                                    final boolean sub_status = call.argument("subscription_flag");
                                    mPushConnector.setSubscription(sub_status);
                                    break;
                            }
                        }
                );
    }
}
