package com.example.HelloFlutterJava

import ie.imobile.extremepush.PushConnector
import io.flutter.embedding.android.FlutterActivity
import io.flutter.embedding.engine.FlutterEngine
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel

class MainActivity : FlutterActivity() {
    override fun configureFlutterEngine(flutterEngine: FlutterEngine) {
        super.configureFlutterEngine(flutterEngine)
        MethodChannel(flutterEngine.dartExecutor.binaryMessenger, CHANNEL)
                .setMethodCallHandler { call: MethodCall, result: MethodChannel.Result? ->
                    when (call.method) {
                        "hitEvent" -> {
                            val xpEvent = call.argument<String>("xpEvent")
                            PushConnector.mPushConnector.hitEvent(xpEvent)
                        }
                        "hitTag" -> {
                            val xpTag = call.argument<String>("xpTag")
                            PushConnector.mPushConnector.hitTag(xpTag)
                        }
                        "hitTagWithValue" -> {
                            val xpTagw = call.argument<String>("xpTag")
                            val xpTagValue = call.argument<String>("xpTagValue")
                            PushConnector.mPushConnector.hitTag(xpTagw, xpTagValue)
                        }
                        "setUser" -> {
                            val user_id = call.argument<String>("xp_user_id")
                            PushConnector.mPushConnector.setUser(user_id)
                        }
                        "setTempUser" -> {
                            val temp_user_id = call.argument<String>("xp_temp_user_id")
                            PushConnector.mPushConnector.setTempUser(temp_user_id)
                        }
                        "openInbox" -> PushConnector.mPushConnector.openInbox(this)
                        "setSubscription" -> {
                            val sub_status = call.argument<Boolean>("subscription_flag")!!
                            PushConnector.mPushConnector.setSubscription(sub_status)
                        }
                    }
                }
    }
    companion object {
        private const val CHANNEL = "ie.imobile.xtremepush/flutter"
    }
}