#import "AppDelegate.h"
#import <Flutter/Flutter.h>
#import "GeneratedPluginRegistrant.h"
#import <XPush/XPush.h>
​
@implementation AppDelegate
​
- (BOOL)application:(UIApplication *)application
    didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    
    [XPush setAppKey: @"YOUR_XTREMEPUSH_APPLICATION_KEY"];
    [XPush setShouldShowDebugLogs:YES];
    [XPush registerForRemoteNotificationTypes:XPNotificationType_Badge| XPNotificationType_Alert | XPNotificationType_Sound];
    [XPush setSandboxModeEnabled:YES];
    
    [XPush applicationDidFinishLaunchingWithOptions:launchOptions];
    
    
    
    FlutterViewController* controller = (FlutterViewController*)self.window.rootViewController;
​
      FlutterMethodChannel* xtremepushChannel = [FlutterMethodChannel
                                              methodChannelWithName:@"ie.imobile.xtremepush/flutter"
                                              binaryMessenger:controller.binaryMessenger];
​
    [xtremepushChannel setMethodCallHandler:^(FlutterMethodCall* call, FlutterResult result) {
        
    
        if ([@"hitEvent" isEqualToString:call.method]) {
            NSString *xpEvent = call.arguments[@"xpEvent"];
            [XPush hitEvent: xpEvent];
        }
        if ([@"hitTag" isEqualToString:call.method]) {
            NSString *xpTag = call.arguments[@"xpTag"];
            [XPush hitEvent: xpTag];
        }
        if ([@"hitTagWithValue" isEqualToString:call.method]) {
            NSString *xpTag = call.arguments[@"xpTag"];
            NSString *xpTagValue = call.arguments[@"xpTagValue"];
            [XPush hitTag: xpTag withValue:xpTagValue];
        }
        if ([@"setUser" isEqualToString:call.method]) {
            NSString *xpUser = call.arguments[@"xp_user_id"];
            [XPush setUser: xpUser];
        }
        if ([@"setTempUser" isEqualToString:call.method]) {
            NSString *xpUser = call.arguments[@"xp_temp_user_id"];
            [XPush setTempUser: xpUser];
        }
        if ([@"openInbox" isEqualToString:call.method]) {
            [XPush openInbox];
        }
        if ([@"setSubscription" isEqualToString:call.method]) {
            BOOL subscription_flag = call.arguments[@"subscription_flag"];
            [XPush setSubscription: subscription_flag];
        }
      }];
    
    
    
  [GeneratedPluginRegistrant registerWithRegistry:self];
  // Override point for customization after application launch.
  return [super application:application didFinishLaunchingWithOptions:launchOptions];
}
​
- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken {
    [XPush applicationDidRegisterForRemoteNotificationsWithDeviceToken:deviceToken];
}
​
@end
