@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {
  override func application(
    _ application: UIApplication,
    didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
    XPush.setAppKey(<#T##appKey: String!##String!#>)
    XPush.applicationDidFinishLaunching(options: launchOptions)
    let controller : FlutterViewController = window?.rootViewController as! FlutterViewController
    let batteryChannel = FlutterMethodChannel(name: "samples.flutter.dev/battery",
                                              binaryMessenger: controller.binaryMessenger)
    batteryChannel.setMethodCallHandler({
      (call: FlutterMethodCall, result: @escaping FlutterResult) -> Void in
        switch call.method {
        case "hitEvent":
            let xpEvent = call.arguments["xpEvent"] as! String
            XPush.hitEvent(xpEvent)
        case "hitTag":
            let xpTag = call.arguments["xpTag"] as! String;
            XPush.hitTag(xpTag)
        case "hitTagWithValue":
            let xpTag = call.arguments["xpTag"] as! String;
            let xpTagValue = call.arguments["xpTagValue"] as! String;
            XPush.hitTag(xpTag, withValue: xpTagValue)
        case "setUser":
            let userId = call.arguments["xp_user_id"] as! String;
            XPush.setUser(userId)
        case "setTempUser":
            let userId = call.arguments["xp_temp_user_id"] as! String;
            XPush.setTempUser(userId)
        case "openInbox":
            XPush.openInbox()
        case "setSubscription":
            let subscription_flag = (call.arguments["xp_temp_user_id"] as! NSNumber).boolValue;
            XPush.setSubscription(subscription_flag)
        }
    })
    GeneratedPluginRegistrant.register(with: self)
    return super.application(application, didFinishLaunchingWithOptions: launchOptions)
  }
    func application(_ application: UIApplication, didRegisterForRemoteNotificationsWithDeviceToken deviceToken: Data) {
        XPush.applicationDidRegisterForRemoteNotifications(withDeviceToken: deviceToken)
    }
}